#include "tiles.h"
#include "global.h"
#ifdef FR_OPEN_MAP
    #include "map_io.h"
#endif
/**********************************************************************/

int start_rendering()
{
    int done = 0;
    Uint32 last_save_time=0;
	/* Loop until done. */
	while( !done ) {
		SDL_Event event;

    		cur_time = SDL_GetTicks();
		/* Check if there's a pending event. */

		while( SDL_PollEvent( &event ) )
        {
            done = HandleEvent(&event);
#ifndef ENGLISH
            if( done == -1 )
                break;
#endif //ENGLISH
		}

    		get_world_x_y();

		if(!limit_fps || ((cur_time - last_time) && (800/(cur_time-last_time) < (Uint32)limit_fps)))
			{
				draw_scene();
				last_time=cur_time;
			}
		else SDL_Delay(1);

		if(auto_save_time && (cur_time-last_save_time)>(Uint32)auto_save_time)
			{
				last_save_time=cur_time;
				save_map("maps/Autosave.elm");
			}

// --- TRINITA GTK2 EYE_CANDY #if defined(LINUX) || defined(BSD)
		while (gtk_events_pending())
			gtk_main_iteration();
// --- TRINITA GTK2 EYE_CANDY #endif
	}

	/* Destroy our GL context, etc. */
#ifndef ENGLISH
	FreeXML(help_doc);
#endif
	destroy_map_tiles();
	SDL_SetTimer(0,NULL);
	end_particles ();
	SDL_Quit( );
	return(0);
}

int Main(int argc, char *argv[])
{

        //int i
  	//int logo = 1;
	//int numtests = 1;
	//int bpp = 0;
	//int slowly = 1;
	//float gamma = 0.0;
	//int noframe = 1;

// --- TRINITA GTK2 EYE_CANDY #if defined(LINUX) || defined(BSD)
     gtk_set_locale ();
	gtk_init (&argc, &argv);
// --- TRINITA GTK2 EYE_CANDY #endif	//LINUX || BSD
	init_stuff();

#if defined(LINUX) || defined(BSD)
#ifdef FR_OPEN_MAP
    if( argc >= 2 )
    {
        /*
            Trinita
            -m[1] path of map[2]    // pour ouvrir une map en ligne de commande
            -x[3] coord x[4]        // la coordonne x en dcimal (ex: 19 )
            -y[5] coord y[6]        // idem mais pour y
        */
        int iBoucle = 0;
        for( iBoucle=1;iBoucle < argc;iBoucle++)
        {
            if( strcmp( argv[iBoucle], "-m") == 0 )
            {
                iBoucle++;  // --- +1 pour avoir le param qui suit
                if( file_exists(argv[iBoucle]) )
                {
                   load_map( argv[iBoucle] );
                }
                else
                    printf("This file not exists !\n");
            }

            if( strcmp( argv[iBoucle], "-x") == 0  )
            {
                iBoucle++;
                mx = strtol(argv[iBoucle], NULL, 10);
            }

            if( strcmp( argv[iBoucle], "-y") == 0  )
            {
                iBoucle++;
                my = strtol(argv[iBoucle], NULL, 10);
            }

            if( strcmp( argv[iBoucle], "-h") == 0  )
            {
                iBoucle++;
                printf("Editeur de cartes des Landes Eternelles :\n");
                printf("Aide \n");
                printf("-m chemin+nom de la carte a ouvrir\n");
                printf("-x la coordonnee x pour positionner la carte\n");
                printf("-y la coordonnee y pour positionner la carte\n");
            }
        }


    }
#endif
#endif	//LINUX || BSD

    start_rendering();

	return 0;
}

#if defined(LINUX) || defined(BSD)
int main(int argc, char *argv[])
{
  return Main(argc, argv);
}
#endif

#if !defined(LINUX) && !defined(BSD)
int WINAPI WinMain (HINSTANCE hInst, HINSTANCE hPrev, LPSTR lpCmd, int nShow)
{
Main(0, NULL);
  return 0;
}
#endif
